
#define    MAX_INTENSITY    65535                /* for X11 */

typedef    struct _RGB {
    unsigned short r, g, b;
} RGB;

typedef    struct _RGBf {
    float r, g, b;
} RGBf;

typedef    struct _HSV {
    float    h, s, v;    /* [0, 1] */
} HSV;

typedef    struct _HLS {
    float    h, l, s;    /* [0, 1] */
} HLS;

typedef    struct _CIE {
    float    X, Y, Z;    /* Y e [0, 1] */
} CIE;

typedef struct _CMY {
    unsigned short c, m, y;
} CMY;

#define OP_RGB 1
#define OP_HSV 2
#define OP_HLS 3
#define OP_CIE 4

float RGBDist();
RGB   MixRGB();
RGB   MixHSV();
RGB   HSVToRGB();
RGB   HLSToRGB();
RGB   CIEToRGB();
RGB   CMYToRGB();
RGB   PctToRGB();
RGBf  CIEToRGBs();

HLS   RGBToHLS();

HSV   RGBToHSV();
HSV   PctToHSV();

CMY   RGBToCMY();

CIE   RGBToCIE();

