
#include "x.h"
#include "xt.h"
#include "globals.h"
#include "defs.h"
#include "externs.h"
#include <stdio.h>
#ifdef XPM
#include <X11/xpm.h>
#endif


#ifdef XPM
void errorMessageXPM(ErrorStatus, tag)
int ErrorStatus;
char *tag;
{
    char *error = NULL;
    char *warning = NULL;

    switch (ErrorStatus) {
    case XpmSuccess:
        return;
    case XpmColorError:
        warning = "Could not parse or alloc requested color";
        break;
    case XpmOpenFailed:
        error = "Cannot open file";
        break;
    case XpmFileInvalid:
        error = "Invalid XPM file";
        break;
    case XpmNoMemory:
        error = "Not enough memory";
        break;
    case XpmColorFailed:
        error = "Failed to parse or alloc some color";
        break;
    }

    if (warning)
        printf("%s Xpm Warning: %s.\n", tag, warning);

    if (error) {
        printf("%s Xpm Error: %s.\n", tag, error);
/*      exit( -1 ); */
    }
}
#endif


#define viewTypeMENUITEMS 2
char   *viewTypeMENUEntry[] = { "Perspective", "Parallel" };

#define viewClipMENUITEMS 4
char   *viewClipMENUEntry[] = { "Back", "Front", "XY", "All" };

#define xlogo11_width  11
#define xlogo11_height 11
static char xlogo11_bits[] = {
 0x0f, 0x04, 0x0f, 0x02, 0x1e, 0x01, 0x3c, 0x01, 0xb8, 0x00, 0x58, 0x00,
 0xe8, 0x00, 0xe4, 0x01, 0xc4, 0x03, 0xc2, 0x03, 0x81, 0x07 };

Pixmap mark;


Widget viewVRPxScroll, viewVRPyScroll, viewVRPzScroll, viewVRPLabel,
       viewVUPxScroll, viewVUPyScroll, viewVUPzScroll, viewVUPLabel,
       viewVPNxScroll, viewVPNyScroll, viewVPNzScroll, viewVPNLabel,
       viewPRPxScroll, viewPRPyScroll, viewPRPzScroll, viewPRPLabel,
       viewBackScroll, viewBackLabel,
       viewViewScroll, viewViewLabel,
       viewFrontScroll, viewFrontLabel,
       viewWindowLLLabel,
       viewWindowURLabel,
       viewTypeLabel, viewTypeButton, viewTypeEntry[viewTypeMENUITEMS],
       viewClipLabel, viewClipButton, viewClipEntry[viewClipMENUITEMS];


void
create_gui( depth, vendor )
int depth;
char *vendor;
{
    int status, i;
    float topOfThumb;
    XtArgVal *l_topOfThumb;
    String string = (String) malloc(30);
    Dimension width, widthW, height;

    extern PEXCoord        view_ref_pt;
    extern PEXVector       view_up_vec;
    extern PEXVector       view_plane_normal;
    extern PEXCoord2D      view_window[2];
    extern PEXNPCSubVolume viewport;
    extern double          view_plane, front_plane, back_plane;
    extern PEXCoord        proj_ref_pt;
    extern int             perspective;

    extern Widget toplevel;
    Widget quit, form, viewForm,
           viewOrienLabel, viewBoundx, viewBoundy, viewBoundz,
           viewMapLabel, viewBoundxx, viewBoundyy, viewBoundzz,
           viewVRP, viewVRPReset,
           viewVUP, viewVUPReset,
           viewVPN, viewVPNReset,
           viewPRP, viewPRPReset;
    Widget viewWindow,
           viewBack, viewBackReset,
           viewView, viewViewReset,
           viewFront, viewFrontReset,
           viewWindowLL, viewWindowLLReset,
           viewWindowUR, viewWindowURReset,
           viewTypeMenu, viewClipMenu;
    Widget viewNPCLabel, viewNPCx, viewNPCy, viewNPCz,
           viewNPCmin, viewNPCminxScroll, viewNPCminyScroll, viewNPCminzScroll,
           viewNPCminLabel, viewNPCminReset,
           viewNPCmax, viewNPCmaxxScroll, viewNPCmaxyScroll, viewNPCmaxzScroll,
           viewNPCmaxLabel, viewNPCmaxReset;

#ifdef XPM
    Pixmap backPixmap, pix;
    XpmAttributes attributes;

    if( depth == 8 || (strcmp( vendor, "International Business Machines" )) ) {
        attributes.valuemask = XpmReturnPixels;
        status = XpmReadFileToPixmap( XtDisplay(toplevel),
            DefaultRootWindow(XtDisplay(toplevel)),
            "pixmaps/background.xpm", &backPixmap, &pix, &attributes );
        errorMessageXPM( status, "Background" );
    }
#endif

    /* Create the widgets. */
    if( depth == 8 || (strcmp( vendor, "International Business Machines" )) )
    form = XtVaCreateManagedWidget( "form", formWidgetClass, toplevel,
#ifdef XPM
        XtNbackgroundPixmap, backPixmap,
#endif
        NULL );
    else
    form = XtVaCreateManagedWidget( "form", formWidgetClass, toplevel,
        NULL );

    canvas = XtVaCreateManagedWidget( "canvas", formWidgetClass, form,
        XtNwidth, 210,
        XtNheight, 210,
        NULL );
    XtAddEventHandler( canvas, ExposureMask, FALSE, expose, NULL );

    /* The reflectance properties panel. */
    if( depth == 8 || (strcmp( vendor, "International Business Machines" )) )
    viewForm = XtVaCreateManagedWidget( "viewForm", formWidgetClass,
        form,
        XtNfromHoriz, canvas,
        XtNborderWidth, 0,
#ifdef XPM
        XtNbackgroundPixmap, backPixmap,
#endif
        NULL );
    else
    viewForm = XtVaCreateManagedWidget( "viewForm", formWidgetClass,
        form,
        XtNfromHoriz, canvas,
        XtNborderWidth, 0,
        NULL );

    viewOrienLabel = XtVaCreateManagedWidget( "OrienLabel", labelWidgetClass,
        viewForm,
        XtNlabel, "View Orientation Matrix:",
        XtNborderWidth, 0,
        NULL );

    viewBoundx = XtVaCreateManagedWidget( "Boundx", labelWidgetClass,
        viewForm,
        XtNlabel, "-10.0 <= x <= 10.0",
        XtNfromVert, viewOrienLabel,
        XtNhorizDistance, 50,
        NULL );
    XtVaGetValues( viewBoundx, XtNwidth, &width, NULL );

    viewBoundy = XtVaCreateManagedWidget( "Boundy", labelWidgetClass,
        viewForm,
        XtNlabel, "-10.0 <= y <= 10.0",
        XtNfromVert, viewOrienLabel,
        XtNfromHoriz, viewBoundx,
        NULL );

    viewBoundz = XtVaCreateManagedWidget( "Boundz", labelWidgetClass,
        viewForm,
        XtNlabel, "-10.0 <= z <= 10.0",
        XtNfromVert, viewOrienLabel,
        XtNfromHoriz, viewBoundy,
        NULL );

    viewVRP = XtVaCreateManagedWidget( "VRP", labelWidgetClass,
        viewForm,
        XtNlabel, "VRP:",
        XtNfromVert, viewBoundx,
        NULL );
    XtVaGetValues( viewVRP, XtNheight, &height, NULL );

    topOfThumb = 0.5 + view_ref_pt.x / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewVRPxScroll = XtVaCreateManagedWidget( "VRPxScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewBoundx,
        XtNfromHoriz, viewVRP,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewVRPxScroll, XtNjumpProc, set_vrp, (XtPointer)VRP_X );

    topOfThumb = 0.5 + view_ref_pt.y / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewVRPyScroll = XtVaCreateManagedWidget( "VRPyScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewBoundx,
        XtNfromHoriz, viewVRPxScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewVRPyScroll, XtNjumpProc, set_vrp, (XtPointer)VRP_Y );

    topOfThumb = 0.5 + view_ref_pt.z / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewVRPzScroll = XtVaCreateManagedWidget( "VRPzScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewBoundx,
        XtNfromHoriz, viewVRPyScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewVRPzScroll, XtNjumpProc, set_vrp, (XtPointer)VRP_Z );

    sprintf( string, "(%.2f,%.2f,%.2f)",
        view_ref_pt.x, view_ref_pt.y, view_ref_pt.z );
    viewVRPLabel = XtVaCreateManagedWidget( "VRPLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewBoundx,
        XtNfromHoriz, viewVRPzScroll,
        XtNlabel, string,
        XtNwidth, 180,
        NULL );

    viewVRPReset = XtVaCreateManagedWidget( "VRPReset",
        commandWidgetClass,
        viewForm,
        XtNfromVert, viewBoundx,
        XtNfromHoriz, viewVRPLabel,
        XtNlabel, "Reset",
        NULL );
    XtAddCallback( viewVRPReset, XtNcallback, reset_vrp, (XtPointer)VRP_ALL );

    viewVUP = XtVaCreateManagedWidget( "VUP", labelWidgetClass,
        viewForm,
        XtNlabel, "VUP:",
        XtNfromVert, viewVRP,
        NULL );

    topOfThumb = 0.5 + view_up_vec.x / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewVUPxScroll = XtVaCreateManagedWidget( "VUPxScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewVRP,
        XtNfromHoriz, viewVUP,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewVUPxScroll, XtNjumpProc, set_vup, (XtPointer)VUP_X );

    topOfThumb = 0.5 + view_up_vec.y / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewVUPyScroll = XtVaCreateManagedWidget( "VUPyScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewVRP,
        XtNfromHoriz, viewVUPxScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewVUPyScroll, XtNjumpProc, set_vup, (XtPointer)VUP_Y );

    topOfThumb = 0.5 + view_up_vec.z / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewVUPzScroll = XtVaCreateManagedWidget( "viewVUPzScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewVRP,
        XtNfromHoriz, viewVUPyScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewVUPzScroll, XtNjumpProc, set_vup, (XtPointer)VUP_Z );

    sprintf( string, "(%.2f,%.2f,%.2f)",
        view_up_vec.x, view_up_vec.y, view_up_vec.z );
    viewVUPLabel = XtVaCreateManagedWidget( "VUPLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewVRP,
        XtNfromHoriz, viewVUPzScroll,
        XtNlabel, string,
        XtNwidth, 180,
        NULL );

    viewVUPReset = XtVaCreateManagedWidget( "VUPReset",
        commandWidgetClass,
        viewForm,
        XtNfromVert, viewVRP,
        XtNfromHoriz, viewVUPLabel,
        XtNlabel, "Reset",
        NULL );
    XtAddCallback( viewVUPReset, XtNcallback, reset_vup, (XtPointer)VUP_ALL );

    viewVPN = XtVaCreateManagedWidget( "VPN", labelWidgetClass,
        viewForm,
        XtNlabel, "VPN:",
        XtNfromVert, viewVUP,
        NULL );

    topOfThumb = 0.5 + view_plane_normal.x / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewVPNxScroll = XtVaCreateManagedWidget( "VPNxScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewVUP,
        XtNfromHoriz, viewVPN,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewVPNxScroll, XtNjumpProc, set_vpn, (XtPointer)VPN_X );

    topOfThumb = 0.5 + view_plane_normal.y / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewVPNyScroll = XtVaCreateManagedWidget( "VPNyScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewVUP,
        XtNfromHoriz, viewVPNxScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewVPNyScroll, XtNjumpProc, set_vpn, (XtPointer)VPN_Y );

    topOfThumb = 0.5 + view_plane_normal.z / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewVPNzScroll = XtVaCreateManagedWidget( "viewVPNzScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewVUP,
        XtNfromHoriz, viewVPNyScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewVPNzScroll, XtNjumpProc, set_vpn, (XtPointer)VPN_Z );

    sprintf( string, "(%.2f,%.2f,%.2f)",
        view_plane_normal.x, view_plane_normal.y, view_plane_normal.z );
    viewVPNLabel = XtVaCreateManagedWidget( "VPNLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewVUP,
        XtNfromHoriz, viewVPNzScroll,
        XtNlabel, string,
        XtNwidth, 180,
        NULL );

    viewVPNReset = XtVaCreateManagedWidget( "VPNReset",
        commandWidgetClass,
        viewForm,
        XtNfromVert, viewVUP,
        XtNfromHoriz, viewVPNLabel,
        XtNlabel, "Reset",
        NULL );
    XtAddCallback( viewVPNReset, XtNcallback, reset_vpn, (XtPointer)VPN_ALL );

    viewMapLabel = XtVaCreateManagedWidget( "MapLabel", labelWidgetClass,
        viewForm,
        XtNfromVert, viewVPN,
        XtNlabel, "View Mapping Matrix:",
        XtNborderWidth, 0,
        NULL );

    viewBoundxx = XtVaCreateManagedWidget( "Boundxx", labelWidgetClass,
        viewForm,
        XtNlabel, "-10.0 <= x <= 10.0",
        XtNfromVert, viewMapLabel,
        XtNhorizDistance, 50,
        NULL );
    XtVaGetValues( viewBoundxx, XtNwidth, &width, NULL );

    viewBoundyy = XtVaCreateManagedWidget( "Boundyy", labelWidgetClass,
        viewForm,
        XtNlabel, "-10.0 <= y <= 10.0",
        XtNfromVert, viewMapLabel,
        XtNfromHoriz, viewBoundxx,
        NULL );

    viewBoundzz = XtVaCreateManagedWidget( "Boundzz", labelWidgetClass,
        viewForm,
        XtNlabel, "-10.0 <= z <= 10.0",
        XtNfromVert, viewMapLabel,
        XtNfromHoriz, viewBoundyy,
        NULL );

    viewPRP = XtVaCreateManagedWidget( "PRP", labelWidgetClass,
        viewForm,
        XtNlabel, "PRP:",
        XtNfromVert, viewBoundxx,
        NULL );

    topOfThumb = 0.5 + proj_ref_pt.x / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewPRPxScroll = XtVaCreateManagedWidget( "PRPxScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewBoundxx,
        XtNfromHoriz, viewPRP,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewPRPxScroll, XtNjumpProc, set_prp, (XtPointer)PRP_X );

    topOfThumb = 0.5 + proj_ref_pt.y / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewPRPyScroll = XtVaCreateManagedWidget( "PRPyScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewBoundxx,
        XtNfromHoriz, viewPRPxScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewPRPyScroll, XtNjumpProc, set_prp, (XtPointer)PRP_Y );

    topOfThumb = 0.5 + proj_ref_pt.z / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewPRPzScroll = XtVaCreateManagedWidget( "viewPRPzScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewBoundxx,
        XtNfromHoriz, viewPRPyScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewPRPzScroll, XtNjumpProc, set_prp, (XtPointer)PRP_Z );

    sprintf( string, "(%.2f,%.2f,%.2f)",
        proj_ref_pt.x, proj_ref_pt.y, proj_ref_pt.z );
    viewPRPLabel = XtVaCreateManagedWidget( "PRPLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewBoundxx,
        XtNfromHoriz, viewPRPzScroll,
        XtNlabel, string,
        XtNwidth, 180,
        NULL );

    viewPRPReset = XtVaCreateManagedWidget( "PRPReset",
        commandWidgetClass,
        viewForm,
        XtNfromVert, viewBoundxx,
        XtNfromHoriz, viewPRPLabel,
        XtNlabel, "Reset",
        NULL );
    XtAddCallback( viewPRPReset, XtNcallback, reset_prp, (XtPointer)PRP_ALL );

    viewWindow = XtVaCreateManagedWidget( "ViewWindow",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewPRP,
        XtNlabel, "View Window:",
        NULL );
    XtVaGetValues( viewWindow, XtNwidth, &widthW, NULL );

    canvasWindow = XtVaCreateManagedWidget( "canvasWindow",
        formWidgetClass,
        viewForm,
        XtNfromVert, viewPRP,
        XtNfromHoriz, viewWindow,
        XtNwidth, 109,
        XtNheight, 109,
        NULL );
    XtAddEventHandler( canvasWindow, ExposureMask, FALSE,
        exposeWindow, NULL );
    XtAddEventHandler( canvasWindow, Button1MotionMask, FALSE,
        motionWindow, NULL );
    XtAddEventHandler( canvasWindow, ButtonPressMask, FALSE,
        pressWindow, NULL );
    XtAddEventHandler( canvasWindow, ButtonReleaseMask, FALSE,
        releaseWindow, NULL );

    viewWindowLL = XtVaCreateManagedWidget( "WindowLL",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewWindow,
        XtNlabel, "LL:",
        NULL );

    sprintf( string, "%.2f,%.2f",
        view_window[0].x, view_window[0].y );
    viewWindowLLLabel = XtVaCreateManagedWidget( "WindowLLLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewWindowLL,
        XtNlabel, string,
        XtNwidth, widthW,
        NULL );

    viewWindowLLReset = XtVaCreateManagedWidget( "WindowLLReset",
        commandWidgetClass,
        viewForm,
        XtNfromVert, viewWindow,
        XtNfromHoriz, viewWindowLL,
        XtNhorizDistance, 22,
        XtNlabel, "Reset",
        NULL );
    XtAddCallback( viewWindowLLReset, XtNcallback, reset_window,
        (XtPointer)WIN_LL );

    viewWindowUR = XtVaCreateManagedWidget( "ViewWindowUR",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewWindowLLLabel,
        XtNlabel, "UR:",
        NULL );

    sprintf( string, "%.2f,%.2f",
        view_window[1].x, view_window[1].y );
    viewWindowURLabel = XtVaCreateManagedWidget( "WindowURLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewWindowUR,
        XtNlabel, string,
        XtNwidth, widthW,
        NULL );

    viewWindowURReset = XtVaCreateManagedWidget( "WindowURReset",
        commandWidgetClass,
        viewForm,
        XtNfromVert, viewWindowLLLabel,
        XtNfromHoriz, viewWindowUR,
        XtNhorizDistance, 22,
        XtNlabel, "Reset",
        NULL );
    XtAddCallback( viewWindowURReset, XtNcallback, reset_window,
        (XtPointer)WIN_UR );

    viewBack = XtVaCreateManagedWidget( "ViewBack",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewPRP,
        XtNfromHoriz, canvasWindow,
        XtNhorizDistance, 39,
        XtNlabel, "Back Plane:",
        NULL );

    topOfThumb = 0.5 + back_plane / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewBackScroll = XtVaCreateManagedWidget( "viewBackScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewPRP,
        XtNfromHoriz, viewBack,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewBackScroll, XtNjumpProc, set_planes, (XtPointer)BACK );

    sprintf( string, "(%.2f)", back_plane );
    viewBackLabel = XtVaCreateManagedWidget( "BackLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewPRP,
        XtNfromHoriz, viewBackScroll,
        XtNlabel, string,
        XtNwidth, 70,
        NULL );

    viewBackReset = XtVaCreateManagedWidget( "BackReset",
        commandWidgetClass,
        viewForm,
        XtNfromVert, viewPRP,
        XtNfromHoriz, viewBackLabel,
        XtNlabel, "Reset",
        NULL );
    XtAddCallback( viewBackReset, XtNcallback, reset_planes, (XtPointer)BACK );

    viewView = XtVaCreateManagedWidget( "ViewPlane",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewBack,
        XtNfromHoriz, canvasWindow,
        XtNhorizDistance, 39,
        XtNlabel, "View Plane:",
        NULL );

    topOfThumb = 0.5 + view_plane / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewViewScroll = XtVaCreateManagedWidget( "viewViewScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewBack,
        XtNfromHoriz, viewView,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewViewScroll, XtNjumpProc, set_planes, (XtPointer)VIEW );

    sprintf( string, "(%.2f)", view_plane );
    viewViewLabel = XtVaCreateManagedWidget( "ViewLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewBack,
        XtNfromHoriz, viewViewScroll,
        XtNlabel, string,
        XtNwidth, 70,
        NULL );

    viewViewReset = XtVaCreateManagedWidget( "ViewReset",
        commandWidgetClass,
        viewForm,
        XtNfromVert, viewBack,
        XtNfromHoriz, viewViewLabel,
        XtNlabel, "Reset",
        NULL );
    XtAddCallback( viewViewReset, XtNcallback, reset_planes, (XtPointer)VIEW );

    viewFront = XtVaCreateManagedWidget( "ViewFront",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewView,
        XtNfromHoriz, canvasWindow,
        XtNhorizDistance, 31,
        XtNlabel, "Front Plane:",
        NULL );

    topOfThumb = 0.5 + front_plane / 20.;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewFrontScroll = XtVaCreateManagedWidget( "viewFrontScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewView,
        XtNfromHoriz, viewFront,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewFrontScroll, XtNjumpProc, set_planes,
        (XtPointer)FRONT );

    sprintf( string, "(%.2f)", front_plane );
    viewFrontLabel = XtVaCreateManagedWidget( "FrontLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewView,
        XtNfromHoriz, viewFrontScroll,
        XtNlabel, string,
        XtNwidth, 70,
        NULL );

    viewFrontReset = XtVaCreateManagedWidget( "FrontReset",
        commandWidgetClass,
        viewForm,
        XtNfromVert, viewView,
        XtNfromHoriz, viewFrontLabel,
        XtNlabel, "Reset",
        NULL );
    XtAddCallback( viewFrontReset, XtNcallback, reset_planes,
        (XtPointer)FRONT );

    /* Create the bitmap for marking selected items. */
    mark = XCreateBitmapFromData(
        XtDisplay( toplevel ),
        RootWindowOfScreen( XtScreen( toplevel ) ),
        xlogo11_bits, xlogo11_width, xlogo11_height );

    viewTypeLabel = XtVaCreateManagedWidget( "TypeLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewFront,
        XtNfromHoriz, canvasWindow,
        XtNhorizDistance, 47,
        XtNlabel, "Proj Type:",
        NULL );

    viewTypeButton = XtVaCreateManagedWidget( "viewTypeButton",
        menuButtonWidgetClass,
        viewForm,
        XtNfromVert, viewFront,
        XtNfromHoriz, viewTypeLabel,
        XtNlabel, "Perspective",
        XtNmenuName, "viewTypeMenu",
        NULL );

    viewTypeMenu = XtVaCreatePopupShell( "viewTypeMenu",
        simpleMenuWidgetClass,
        viewTypeButton,
        NULL );

    for( i=0; i < viewTypeMENUITEMS; i++ ) {
        char * item = viewTypeMENUEntry[i];

        viewTypeEntry[i] = XtVaCreateManagedWidget( item,
            smeBSBObjectClass,
            viewTypeMenu,
            NULL );

        if( i == 0 )
        XtVaSetValues( viewTypeEntry[i], XtNleftBitmap, mark, NULL );

        XtAddCallback( viewTypeEntry[i], XtNcallback, set_type, (XtPointer) i);
    }

    viewClipLabel = XtVaCreateManagedWidget( "ClipLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewTypeLabel,
        XtNfromHoriz, canvasWindow,
        XtNhorizDistance, 39,
        XtNlabel, "Clip Flags:",
        NULL );

    viewClipButton = XtVaCreateManagedWidget( "viewClipButton",
        menuButtonWidgetClass,
        viewForm,
        XtNfromVert, viewTypeLabel,
        XtNfromHoriz, viewClipLabel,
        XtNlabel, "All",
        XtNwidth, 55,
        XtNmenuName, "viewClipMenu",
        NULL );

    viewClipMenu = XtVaCreatePopupShell( "viewClipMenu",
        simpleMenuWidgetClass,
        viewClipButton,
        NULL );

    for( i=0; i < viewClipMENUITEMS; i++ ) {
        char * item = viewClipMENUEntry[i];

        viewClipEntry[i] = XtVaCreateManagedWidget( item,
            smeBSBObjectClass,
            viewClipMenu,
            NULL );

        if( i == 3 )
        XtVaSetValues( viewClipEntry[i], XtNleftBitmap, mark, NULL );

        XtAddCallback( viewClipEntry[i], XtNcallback, set_clip, (XtPointer) i);
    }

    viewNPCLabel = XtVaCreateManagedWidget( "NPCLabel",
        labelWidgetClass,
        viewForm,
        XtNfromVert, viewWindowURLabel,
        XtNlabel, "NPC SubVolume:",
        NULL );

    viewNPCx = XtVaCreateManagedWidget( "NPCx", labelWidgetClass,
        viewForm,
        XtNlabel, "0.0 <= x <= 1.0",
        XtNfromVert, viewNPCLabel,
        XtNhorizDistance, 50,
        XtNwidth, width,
        NULL );

    viewNPCy = XtVaCreateManagedWidget( "NPCy", labelWidgetClass,
        viewForm,
        XtNlabel, "0.0 <= y <= 1.0",
        XtNfromVert, viewNPCLabel,
        XtNfromHoriz, viewNPCx,
        XtNwidth, width,
        NULL );

    viewNPCz = XtVaCreateManagedWidget( "NPCz", labelWidgetClass,
        viewForm,
        XtNlabel, "0.0 <= z <= 1.0",
        XtNfromVert, viewNPCLabel,
        XtNfromHoriz, viewNPCy,
        XtNwidth, width,
        NULL );

    viewNPCmin = XtVaCreateManagedWidget( "NPCmin", labelWidgetClass,
        viewForm,
        XtNfromVert, viewNPCx,
        XtNlabel, "min:",
        NULL );

    topOfThumb = viewport.min.x;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewNPCminxScroll = XtVaCreateManagedWidget( "NPCminxScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewNPCx,
        XtNfromHoriz, viewNPCmin,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewNPCminxScroll, XtNjumpProc, set_npc,
        (XtPointer)NPC_MIN_X );

    topOfThumb = viewport.min.y;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewNPCminyScroll = XtVaCreateManagedWidget( "NPCminyScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewNPCx,
        XtNfromHoriz, viewNPCminxScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewNPCminyScroll, XtNjumpProc, set_npc,
        (XtPointer)NPC_MIN_Y );

    topOfThumb = viewport.min.z;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewNPCminzScroll = XtVaCreateManagedWidget( "NPCminzScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewNPCx,
        XtNfromHoriz, viewNPCminyScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewNPCminzScroll, XtNjumpProc, set_npc,
        (XtPointer)NPC_MIN_Z );
#if( 0 ) 
    sprintf( string, "(%.2f,%.2f,%.2f)",
        viewport.min.x, viewport.min.y, viewport.min.z );
    viewNPCminLabel = XtVaCreateManagedWidget( "NPCminLabel", labelWidgetClass,
        viewForm,
        XtNfromVert, viewNPCx,
        XtNfromHoriz, viewNPCminzScroll,
        XtNlabel, string,
        NULL );

    viewNPCminReset = XtVaCreateManagedWidget( "NPCminReset",
        commandWidgetClass,
        viewForm,
        XtNfromVert, viewNPCx,
        XtNfromHoriz, viewNPCminLabel,
        XtNlabel, "Reset",
        NULL );
#endif		/*  */
    viewNPCmax = XtVaCreateManagedWidget( "NPCmax", labelWidgetClass,
        viewForm,
        XtNfromVert, viewNPCmin,
        XtNlabel, "max:",
        NULL );

    topOfThumb = viewport.max.x;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewNPCmaxxScroll = XtVaCreateManagedWidget( "NPCmaxxScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewNPCmin,
        XtNfromHoriz, viewNPCmax,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewNPCmaxxScroll, XtNjumpProc, set_npc,
        (XtPointer)NPC_MAX_X );

    topOfThumb = viewport.max.y;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewNPCmaxyScroll = XtVaCreateManagedWidget( "NPCmaxyScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewNPCmin,
        XtNfromHoriz, viewNPCmaxxScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewNPCmaxyScroll, XtNjumpProc, set_npc,
        (XtPointer)NPC_MAX_Y );

    topOfThumb = viewport.max.z;
    l_topOfThumb = (XtArgVal *) &topOfThumb;
    viewNPCmaxzScroll = XtVaCreateManagedWidget( "NPCmaxzScroll",
        scrollbarWidgetClass,
        viewForm,
        XtNfromVert, viewNPCmin,
        XtNfromHoriz, viewNPCmaxyScroll,
        XtNtopOfThumb, *l_topOfThumb,
        XtNwidth, width,
        XtNheight, height,
        NULL );
    XtAddCallback( viewNPCmaxzScroll, XtNjumpProc, set_npc,
        (XtPointer)NPC_MAX_Z );
#if( 0 ) 
    sprintf( string, "(%.2f,%.2f,%.2f)",
        viewport.max.x, viewport.max.y, viewport.max.z );
    viewNPCmaxLabel = XtVaCreateManagedWidget( "NPCmaxLabel", labelWidgetClass,
        viewForm,
        XtNfromVert, viewNPCmin,
        XtNfromHoriz, viewNPCmaxzScroll,
        XtNlabel, string,
        NULL );

    viewNPCmaxReset = XtVaCreateManagedWidget( "NPCmaxReset",
        commandWidgetClass,
        viewForm,
        XtNfromVert, viewNPCmin,
        XtNfromHoriz, viewNPCmaxLabel,
        XtNlabel, "Reset",
        NULL );
#endif		/*  */
    quit = XtVaCreateManagedWidget( "quit", commandWidgetClass, form,
        XtNfromVert, canvas,
        XtNlabel, "Quit",
        NULL );
    XtAddCallback( quit, XtNcallback, finalQuit, NULL );
}

void
finalQuit( w, client_data, call_data )
Widget w;
XtPointer client_data, call_data;
{
    extern XtAppContext app;
    extern void printView();

    printView();
    XtDestroyApplicationContext( app );
    (void) exit (0);
}
