
#include "xpex.h"
#include <stdio.h>

extern PEXCoord         view_ref_pt;
extern PEXVector        view_up_vec;
extern PEXVector        view_plane_normal;
extern PEXCoord2D       view_window[2];
extern PEXNPCSubVolume  viewport;
extern double           view_plane, front_plane, back_plane;
extern PEXCoord         proj_ref_pt;
extern int              perspective;
extern PEXViewEntry     view;
extern PEXRendererAttributes rattrs;


void printView()
{
    fprintf( stdout, "VRP %.2f %.2f %.2f VUP %.2f %.2f %.2f VPN %.2f %.2f %.2f\n", view_ref_pt.x, view_ref_pt.y, view_ref_pt.z, view_up_vec.x, view_up_vec.y, view_up_vec.z, view_plane_normal.x, view_plane_normal.y, view_plane_normal.z );
    fprintf( stdout, "PRP %.2f %.2f %.2f Back %.2f View %.2f Front %.2f Type %d\n", proj_ref_pt.x, proj_ref_pt.y, proj_ref_pt.z, back_plane, view_plane, front_plane, perspective );
    fprintf( stdout, "VW LL %.2f %.2f UR %.2f %.2f\n", view_window[0].x, view_window[0].y, view_window[1].x, view_window[1].y );
    fprintf( stdout, "SUB BLL %.2f %.2f %.2f FUR %.2f %.2f %.2f\n", viewport.min.x, viewport.min.y, viewport.min.z, viewport.max.x, viewport.max.y, viewport.max.z );
    fprintf( stdout, "Clip Fl %d Lm BLL %.2f %.2f %.2f FUR %.2f %.2f %.2f\n", view.clip_flags, view.clip_limits.min.x, view.clip_limits.min.y, view.clip_limits.min.z, view.clip_limits.max.x, view.clip_limits.max.y, view.clip_limits.max.z );
#if( 0 ) 
    fprintf( stdout, "RSUB BLL %.2f %.2f %.2f FUR %.2f %.2f %.2f\n", rattrs.npc_subvolume.min.x, rattrs.npc_subvolume.min.y, rattrs.npc_subvolume.min.z, rattrs.npc_subvolume.max.x, rattrs.npc_subvolume.max.y, rattrs.npc_subvolume.max.z );
    fprintf( stdout, "RVP BLL %d %d %.2f FUR %d %d %.2f\n", rattrs.viewport.min.x, rattrs.viewport.min.y, rattrs.viewport.min.z, rattrs.viewport.max.x, rattrs.viewport.max.y, rattrs.viewport.max.z );
#endif
}
